package sun.security.krb5;

import sun.security.krb5.internal.Krb5;
import sun.security.krb5.internal.KrbApErrException;
import sun.security.krb5.internal.SeqNumber;
import sun.security.krb5.internal.HostAddress;
import sun.security.krb5.internal.KerberosTime;

abstract class KrbAppMessage
{
    private static boolean DEBUG;
    
    KrbAppMessage() {
    }
    
    void check(KerberosTime withMicroSeconds, Integer n, Integer n2, HostAddress hostAddress, HostAddress hostAddress2, SeqNumber seqNumber, HostAddress obj, HostAddress obj2, boolean b, boolean b2, PrincipalName principalName) throws KrbApErrException {
        if (obj != null && (hostAddress == null || obj == null || !hostAddress.equals(obj))) {
            if (KrbAppMessage.DEBUG && hostAddress == null) {
                System.out.println("packetSAddress is null");
            }
            if (KrbAppMessage.DEBUG && obj == null) {
                System.out.println("sAddress is null");
            }
            throw new KrbApErrException(38);
        }
        else {
            if (obj2 != null && (hostAddress2 == null || obj2 == null || !hostAddress2.equals(obj2))) {
                throw new KrbApErrException(38);
            }
            if (withMicroSeconds != null) {
                if (n != null) {
                    withMicroSeconds = withMicroSeconds.withMicroSeconds((int)n);
                }
                if (!withMicroSeconds.inClockSkew()) {
                    throw new KrbApErrException(37);
                }
            }
            else if (b) {
                throw new KrbApErrException(37);
            }
            if (seqNumber == null && b2) {
                throw new KrbApErrException(400);
            }
            if (n2 != null && seqNumber != null) {
                if ((int)n2 != seqNumber.current()) {
                    throw new KrbApErrException(42);
                }
                seqNumber.step();
            }
            else if (b2) {
                throw new KrbApErrException(42);
            }
            if (withMicroSeconds == null && n2 == null) {
                throw new KrbApErrException(41);
            }
            return;
        }
    }
    
    static {
        KrbAppMessage.DEBUG = Krb5.DEBUG;
    }
}
